# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs

__all__ = [
    'GetRouteAggregationResult',
    'AwaitableGetRouteAggregationResult',
    'get_route_aggregation',
    'get_route_aggregation_output',
]

@pulumi.output_type
class GetRouteAggregationResult:
    """
    A collection of values returned by getRouteAggregation.
    """
    def __init__(__self__, change=None, change_log=None, connections_count=None, description=None, href=None, id=None, name=None, project=None, route_aggregation_id=None, rules_count=None, state=None, type=None, uuid=None):
        if change and not isinstance(change, dict):
            raise TypeError("Expected argument 'change' to be a dict")
        pulumi.set(__self__, "change", change)
        if change_log and not isinstance(change_log, dict):
            raise TypeError("Expected argument 'change_log' to be a dict")
        pulumi.set(__self__, "change_log", change_log)
        if connections_count and not isinstance(connections_count, int):
            raise TypeError("Expected argument 'connections_count' to be a int")
        pulumi.set(__self__, "connections_count", connections_count)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if href and not isinstance(href, str):
            raise TypeError("Expected argument 'href' to be a str")
        pulumi.set(__self__, "href", href)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if project and not isinstance(project, dict):
            raise TypeError("Expected argument 'project' to be a dict")
        pulumi.set(__self__, "project", project)
        if route_aggregation_id and not isinstance(route_aggregation_id, str):
            raise TypeError("Expected argument 'route_aggregation_id' to be a str")
        pulumi.set(__self__, "route_aggregation_id", route_aggregation_id)
        if rules_count and not isinstance(rules_count, int):
            raise TypeError("Expected argument 'rules_count' to be a int")
        pulumi.set(__self__, "rules_count", rules_count)
        if state and not isinstance(state, str):
            raise TypeError("Expected argument 'state' to be a str")
        pulumi.set(__self__, "state", state)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)
        if uuid and not isinstance(uuid, str):
            raise TypeError("Expected argument 'uuid' to be a str")
        pulumi.set(__self__, "uuid", uuid)

    @property
    @pulumi.getter
    def change(self) -> 'outputs.GetRouteAggregationChangeResult':
        """
        Current state of latest Route Aggregation change
        """
        return pulumi.get(self, "change")

    @property
    @pulumi.getter(name="changeLog")
    def change_log(self) -> 'outputs.GetRouteAggregationChangeLogResult':
        """
        Details of the last change on the route aggregation resource
        """
        return pulumi.get(self, "change_log")

    @property
    @pulumi.getter(name="connectionsCount")
    def connections_count(self) -> int:
        """
        Number of Connections attached to route aggregation
        """
        return pulumi.get(self, "connections_count")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Customer-provided route aggregation description
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def href(self) -> str:
        """
        Equinix auto generated URI to the route aggregation resource
        """
        return pulumi.get(self, "href")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The unique identifier of the resource
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Customer provided name of the route aggregation
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def project(self) -> 'outputs.GetRouteAggregationProjectResult':
        """
        Equinix Project attribute object
        """
        return pulumi.get(self, "project")

    @property
    @pulumi.getter(name="routeAggregationId")
    def route_aggregation_id(self) -> str:
        """
        The uuid of the route aggregation this data source should retrieve
        """
        return pulumi.get(self, "route_aggregation_id")

    @property
    @pulumi.getter(name="rulesCount")
    def rules_count(self) -> int:
        """
        Number of Rules attached to route aggregation
        """
        return pulumi.get(self, "rules_count")

    @property
    @pulumi.getter
    def state(self) -> str:
        """
        Value representing provisioning status for the route aggregation resource
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        Equinix defined Route Aggregation Type; BGP*IPv4*PREFIX*AGGREGATION, BGP*IPv6*PREFIX*AGGREGATION
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def uuid(self) -> str:
        """
        Equinix-assigned unique id for the route aggregation resource
        """
        return pulumi.get(self, "uuid")


class AwaitableGetRouteAggregationResult(GetRouteAggregationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRouteAggregationResult(
            change=self.change,
            change_log=self.change_log,
            connections_count=self.connections_count,
            description=self.description,
            href=self.href,
            id=self.id,
            name=self.name,
            project=self.project,
            route_aggregation_id=self.route_aggregation_id,
            rules_count=self.rules_count,
            state=self.state,
            type=self.type,
            uuid=self.uuid)


def get_route_aggregation(route_aggregation_id: Optional[str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRouteAggregationResult:
    """
    Fabric V4 API compatible data resource that allow user to fetch Equinix Fabric Route Aggregation by UUID
    Additional Documentation:
    * API: https://developer.equinix.com/catalog/fabricv4#tag/Route-Aggregations


    :param str route_aggregation_id: The uuid of the route aggregation this data source should retrieve
    """
    __args__ = dict()
    __args__['routeAggregationId'] = route_aggregation_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('equinix:fabric/getRouteAggregation:getRouteAggregation', __args__, opts=opts, typ=GetRouteAggregationResult).value

    return AwaitableGetRouteAggregationResult(
        change=pulumi.get(__ret__, 'change'),
        change_log=pulumi.get(__ret__, 'change_log'),
        connections_count=pulumi.get(__ret__, 'connections_count'),
        description=pulumi.get(__ret__, 'description'),
        href=pulumi.get(__ret__, 'href'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        project=pulumi.get(__ret__, 'project'),
        route_aggregation_id=pulumi.get(__ret__, 'route_aggregation_id'),
        rules_count=pulumi.get(__ret__, 'rules_count'),
        state=pulumi.get(__ret__, 'state'),
        type=pulumi.get(__ret__, 'type'),
        uuid=pulumi.get(__ret__, 'uuid'))
def get_route_aggregation_output(route_aggregation_id: Optional[pulumi.Input[str]] = None,
                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetRouteAggregationResult]:
    """
    Fabric V4 API compatible data resource that allow user to fetch Equinix Fabric Route Aggregation by UUID
    Additional Documentation:
    * API: https://developer.equinix.com/catalog/fabricv4#tag/Route-Aggregations


    :param str route_aggregation_id: The uuid of the route aggregation this data source should retrieve
    """
    __args__ = dict()
    __args__['routeAggregationId'] = route_aggregation_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('equinix:fabric/getRouteAggregation:getRouteAggregation', __args__, opts=opts, typ=GetRouteAggregationResult)
    return __ret__.apply(lambda __response__: GetRouteAggregationResult(
        change=pulumi.get(__response__, 'change'),
        change_log=pulumi.get(__response__, 'change_log'),
        connections_count=pulumi.get(__response__, 'connections_count'),
        description=pulumi.get(__response__, 'description'),
        href=pulumi.get(__response__, 'href'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        project=pulumi.get(__response__, 'project'),
        route_aggregation_id=pulumi.get(__response__, 'route_aggregation_id'),
        rules_count=pulumi.get(__response__, 'rules_count'),
        state=pulumi.get(__response__, 'state'),
        type=pulumi.get(__response__, 'type'),
        uuid=pulumi.get(__response__, 'uuid')))
