# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetStreamAttachmentsResult',
    'AwaitableGetStreamAttachmentsResult',
    'get_stream_attachments',
    'get_stream_attachments_output',
]

@pulumi.output_type
class GetStreamAttachmentsResult:
    """
    A collection of values returned by getStreamAttachments.
    """
    def __init__(__self__, datas=None, filters=None, id=None, pagination=None, sorts=None):
        if datas and not isinstance(datas, list):
            raise TypeError("Expected argument 'datas' to be a list")
        pulumi.set(__self__, "datas", datas)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if pagination and not isinstance(pagination, dict):
            raise TypeError("Expected argument 'pagination' to be a dict")
        pulumi.set(__self__, "pagination", pagination)
        if sorts and not isinstance(sorts, list):
            raise TypeError("Expected argument 'sorts' to be a list")
        pulumi.set(__self__, "sorts", sorts)

    @property
    @pulumi.getter
    def datas(self) -> Sequence['outputs.GetStreamAttachmentsDataResult']:
        """
        Returned list of stream objects
        """
        return pulumi.get(self, "datas")

    @property
    @pulumi.getter
    def filters(self) -> Sequence['outputs.GetStreamAttachmentsFilterResult']:
        """
        List of filters to apply to the stream attachment get request. Maximum of 8. All will be AND'd together with 1 of the 8 being a possible OR group of 3
        """
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The unique identifier of the resource
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def pagination(self) -> 'outputs.GetStreamAttachmentsPaginationResult':
        """
        Pagination details for the returned streams list
        """
        return pulumi.get(self, "pagination")

    @property
    @pulumi.getter
    def sorts(self) -> Optional[Sequence['outputs.GetStreamAttachmentsSortResult']]:
        """
        The list of sort criteria for the stream assets search request
        """
        return pulumi.get(self, "sorts")


class AwaitableGetStreamAttachmentsResult(GetStreamAttachmentsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetStreamAttachmentsResult(
            datas=self.datas,
            filters=self.filters,
            id=self.id,
            pagination=self.pagination,
            sorts=self.sorts)


def get_stream_attachments(filters: Optional[Sequence[Union['GetStreamAttachmentsFilterArgs', 'GetStreamAttachmentsFilterArgsDict']]] = None,
                           pagination: Optional[Union['GetStreamAttachmentsPaginationArgs', 'GetStreamAttachmentsPaginationArgsDict']] = None,
                           sorts: Optional[Sequence[Union['GetStreamAttachmentsSortArgs', 'GetStreamAttachmentsSortArgsDict']]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetStreamAttachmentsResult:
    """
    Fabric V4 API compatible data resource that allow user to fetch Equinix Fabric Stream Attached Assets with filters and pagination details

    Additional Documentation:
    * Getting Started: https://docs.equinix.com/en-us/Content/KnowledgeCenter/Fabric/GettingStarted/Integrating-with-Fabric-V4-APIs/IntegrateWithSink.htm
    * API: https://developer.equinix.com/catalog/fabricv4#tag/Streams

    ## Example Usage

    ```python
    import pulumi
    import pulumi_equinix as equinix

    all = equinix.fabric.get_stream_attachments(filters=[{
            "operator": "=",
            "property": "<filter_property>",
            "values": ["<list_of_values_to_filter>"],
        }],
        pagination={
            "limit": 100,
            "offset": 0,
        },
        sorts=[{
            "direction": "<DESC|ASC>",
            "property": "/uuid",
        }])
    ```


    :param Sequence[Union['GetStreamAttachmentsFilterArgs', 'GetStreamAttachmentsFilterArgsDict']] filters: List of filters to apply to the stream attachment get request. Maximum of 8. All will be AND'd together with 1 of the 8 being a possible OR group of 3
    :param Union['GetStreamAttachmentsPaginationArgs', 'GetStreamAttachmentsPaginationArgsDict'] pagination: Pagination details for the returned streams list
    :param Sequence[Union['GetStreamAttachmentsSortArgs', 'GetStreamAttachmentsSortArgsDict']] sorts: The list of sort criteria for the stream assets search request
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['pagination'] = pagination
    __args__['sorts'] = sorts
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('equinix:fabric/getStreamAttachments:getStreamAttachments', __args__, opts=opts, typ=GetStreamAttachmentsResult).value

    return AwaitableGetStreamAttachmentsResult(
        datas=pulumi.get(__ret__, 'datas'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        pagination=pulumi.get(__ret__, 'pagination'),
        sorts=pulumi.get(__ret__, 'sorts'))
def get_stream_attachments_output(filters: Optional[pulumi.Input[Optional[Sequence[Union['GetStreamAttachmentsFilterArgs', 'GetStreamAttachmentsFilterArgsDict']]]]] = None,
                                  pagination: Optional[pulumi.Input[Union['GetStreamAttachmentsPaginationArgs', 'GetStreamAttachmentsPaginationArgsDict']]] = None,
                                  sorts: Optional[pulumi.Input[Optional[Sequence[Union['GetStreamAttachmentsSortArgs', 'GetStreamAttachmentsSortArgsDict']]]]] = None,
                                  opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetStreamAttachmentsResult]:
    """
    Fabric V4 API compatible data resource that allow user to fetch Equinix Fabric Stream Attached Assets with filters and pagination details

    Additional Documentation:
    * Getting Started: https://docs.equinix.com/en-us/Content/KnowledgeCenter/Fabric/GettingStarted/Integrating-with-Fabric-V4-APIs/IntegrateWithSink.htm
    * API: https://developer.equinix.com/catalog/fabricv4#tag/Streams

    ## Example Usage

    ```python
    import pulumi
    import pulumi_equinix as equinix

    all = equinix.fabric.get_stream_attachments(filters=[{
            "operator": "=",
            "property": "<filter_property>",
            "values": ["<list_of_values_to_filter>"],
        }],
        pagination={
            "limit": 100,
            "offset": 0,
        },
        sorts=[{
            "direction": "<DESC|ASC>",
            "property": "/uuid",
        }])
    ```


    :param Sequence[Union['GetStreamAttachmentsFilterArgs', 'GetStreamAttachmentsFilterArgsDict']] filters: List of filters to apply to the stream attachment get request. Maximum of 8. All will be AND'd together with 1 of the 8 being a possible OR group of 3
    :param Union['GetStreamAttachmentsPaginationArgs', 'GetStreamAttachmentsPaginationArgsDict'] pagination: Pagination details for the returned streams list
    :param Sequence[Union['GetStreamAttachmentsSortArgs', 'GetStreamAttachmentsSortArgsDict']] sorts: The list of sort criteria for the stream assets search request
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['pagination'] = pagination
    __args__['sorts'] = sorts
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('equinix:fabric/getStreamAttachments:getStreamAttachments', __args__, opts=opts, typ=GetStreamAttachmentsResult)
    return __ret__.apply(lambda __response__: GetStreamAttachmentsResult(
        datas=pulumi.get(__response__, 'datas'),
        filters=pulumi.get(__response__, 'filters'),
        id=pulumi.get(__response__, 'id'),
        pagination=pulumi.get(__response__, 'pagination'),
        sorts=pulumi.get(__response__, 'sorts')))
