# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['RouteAggregationArgs', 'RouteAggregation']

@pulumi.input_type
class RouteAggregationArgs:
    def __init__(__self__, *,
                 project: pulumi.Input['RouteAggregationProjectArgs'],
                 type: pulumi.Input[str],
                 description: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 timeouts: Optional[pulumi.Input['RouteAggregationTimeoutsArgs']] = None):
        """
        The set of arguments for constructing a RouteAggregation resource.
        :param pulumi.Input['RouteAggregationProjectArgs'] project: Equinix Project attribute object
        :param pulumi.Input[str] type: Equinix defined Route Aggregation Type; BGP*IPv4*PREFIX*AGGREGATION, BGP*IPv6*PREFIX*AGGREGATION
        :param pulumi.Input[str] description: Customer-provided route aggregation description
        :param pulumi.Input[str] name: Customer provided name of the route aggregation
        """
        pulumi.set(__self__, "project", project)
        pulumi.set(__self__, "type", type)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if timeouts is not None:
            pulumi.set(__self__, "timeouts", timeouts)

    @property
    @pulumi.getter
    def project(self) -> pulumi.Input['RouteAggregationProjectArgs']:
        """
        Equinix Project attribute object
        """
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: pulumi.Input['RouteAggregationProjectArgs']):
        pulumi.set(self, "project", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        Equinix defined Route Aggregation Type; BGP*IPv4*PREFIX*AGGREGATION, BGP*IPv6*PREFIX*AGGREGATION
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Customer-provided route aggregation description
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Customer provided name of the route aggregation
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def timeouts(self) -> Optional[pulumi.Input['RouteAggregationTimeoutsArgs']]:
        return pulumi.get(self, "timeouts")

    @timeouts.setter
    def timeouts(self, value: Optional[pulumi.Input['RouteAggregationTimeoutsArgs']]):
        pulumi.set(self, "timeouts", value)


@pulumi.input_type
class _RouteAggregationState:
    def __init__(__self__, *,
                 change: Optional[pulumi.Input['RouteAggregationChangeArgs']] = None,
                 change_log: Optional[pulumi.Input['RouteAggregationChangeLogArgs']] = None,
                 connections_count: Optional[pulumi.Input[int]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 href: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input['RouteAggregationProjectArgs']] = None,
                 rules_count: Optional[pulumi.Input[int]] = None,
                 state: Optional[pulumi.Input[str]] = None,
                 timeouts: Optional[pulumi.Input['RouteAggregationTimeoutsArgs']] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 uuid: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering RouteAggregation resources.
        :param pulumi.Input['RouteAggregationChangeArgs'] change: Current state of latest Route Aggregation change
        :param pulumi.Input['RouteAggregationChangeLogArgs'] change_log: Details of the last change on the route aggregation resource
        :param pulumi.Input[int] connections_count: Number of Connections attached to route aggregation
        :param pulumi.Input[str] description: Customer-provided route aggregation description
        :param pulumi.Input[str] href: Equinix auto generated URI to the route aggregation resource
        :param pulumi.Input[str] name: Customer provided name of the route aggregation
        :param pulumi.Input['RouteAggregationProjectArgs'] project: Equinix Project attribute object
        :param pulumi.Input[int] rules_count: Number of Rules attached to route aggregation
        :param pulumi.Input[str] state: Value representing provisioning status for the route aggregation resource
        :param pulumi.Input[str] type: Equinix defined Route Aggregation Type; BGP*IPv4*PREFIX*AGGREGATION, BGP*IPv6*PREFIX*AGGREGATION
        :param pulumi.Input[str] uuid: Equinix-assigned unique id for the route aggregation resource
        """
        if change is not None:
            pulumi.set(__self__, "change", change)
        if change_log is not None:
            pulumi.set(__self__, "change_log", change_log)
        if connections_count is not None:
            pulumi.set(__self__, "connections_count", connections_count)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if href is not None:
            pulumi.set(__self__, "href", href)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if project is not None:
            pulumi.set(__self__, "project", project)
        if rules_count is not None:
            pulumi.set(__self__, "rules_count", rules_count)
        if state is not None:
            pulumi.set(__self__, "state", state)
        if timeouts is not None:
            pulumi.set(__self__, "timeouts", timeouts)
        if type is not None:
            pulumi.set(__self__, "type", type)
        if uuid is not None:
            pulumi.set(__self__, "uuid", uuid)

    @property
    @pulumi.getter
    def change(self) -> Optional[pulumi.Input['RouteAggregationChangeArgs']]:
        """
        Current state of latest Route Aggregation change
        """
        return pulumi.get(self, "change")

    @change.setter
    def change(self, value: Optional[pulumi.Input['RouteAggregationChangeArgs']]):
        pulumi.set(self, "change", value)

    @property
    @pulumi.getter(name="changeLog")
    def change_log(self) -> Optional[pulumi.Input['RouteAggregationChangeLogArgs']]:
        """
        Details of the last change on the route aggregation resource
        """
        return pulumi.get(self, "change_log")

    @change_log.setter
    def change_log(self, value: Optional[pulumi.Input['RouteAggregationChangeLogArgs']]):
        pulumi.set(self, "change_log", value)

    @property
    @pulumi.getter(name="connectionsCount")
    def connections_count(self) -> Optional[pulumi.Input[int]]:
        """
        Number of Connections attached to route aggregation
        """
        return pulumi.get(self, "connections_count")

    @connections_count.setter
    def connections_count(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "connections_count", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Customer-provided route aggregation description
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def href(self) -> Optional[pulumi.Input[str]]:
        """
        Equinix auto generated URI to the route aggregation resource
        """
        return pulumi.get(self, "href")

    @href.setter
    def href(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "href", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Customer provided name of the route aggregation
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input['RouteAggregationProjectArgs']]:
        """
        Equinix Project attribute object
        """
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input['RouteAggregationProjectArgs']]):
        pulumi.set(self, "project", value)

    @property
    @pulumi.getter(name="rulesCount")
    def rules_count(self) -> Optional[pulumi.Input[int]]:
        """
        Number of Rules attached to route aggregation
        """
        return pulumi.get(self, "rules_count")

    @rules_count.setter
    def rules_count(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "rules_count", value)

    @property
    @pulumi.getter
    def state(self) -> Optional[pulumi.Input[str]]:
        """
        Value representing provisioning status for the route aggregation resource
        """
        return pulumi.get(self, "state")

    @state.setter
    def state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "state", value)

    @property
    @pulumi.getter
    def timeouts(self) -> Optional[pulumi.Input['RouteAggregationTimeoutsArgs']]:
        return pulumi.get(self, "timeouts")

    @timeouts.setter
    def timeouts(self, value: Optional[pulumi.Input['RouteAggregationTimeoutsArgs']]):
        pulumi.set(self, "timeouts", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        Equinix defined Route Aggregation Type; BGP*IPv4*PREFIX*AGGREGATION, BGP*IPv6*PREFIX*AGGREGATION
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter
    def uuid(self) -> Optional[pulumi.Input[str]]:
        """
        Equinix-assigned unique id for the route aggregation resource
        """
        return pulumi.get(self, "uuid")

    @uuid.setter
    def uuid(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "uuid", value)


class RouteAggregation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[Union['RouteAggregationProjectArgs', 'RouteAggregationProjectArgsDict']]] = None,
                 timeouts: Optional[pulumi.Input[Union['RouteAggregationTimeoutsArgs', 'RouteAggregationTimeoutsArgsDict']]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Fabric V4 API compatible resource allows creation and management of Equinix Fabric Route Aggregation

        Additional Documentation:
        * API: https://developer.equinix.com/catalog/fabricv4#tag/Route-Aggregations

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] description: Customer-provided route aggregation description
        :param pulumi.Input[str] name: Customer provided name of the route aggregation
        :param pulumi.Input[Union['RouteAggregationProjectArgs', 'RouteAggregationProjectArgsDict']] project: Equinix Project attribute object
        :param pulumi.Input[str] type: Equinix defined Route Aggregation Type; BGP*IPv4*PREFIX*AGGREGATION, BGP*IPv6*PREFIX*AGGREGATION
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RouteAggregationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Fabric V4 API compatible resource allows creation and management of Equinix Fabric Route Aggregation

        Additional Documentation:
        * API: https://developer.equinix.com/catalog/fabricv4#tag/Route-Aggregations

        :param str resource_name: The name of the resource.
        :param RouteAggregationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RouteAggregationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[Union['RouteAggregationProjectArgs', 'RouteAggregationProjectArgsDict']]] = None,
                 timeouts: Optional[pulumi.Input[Union['RouteAggregationTimeoutsArgs', 'RouteAggregationTimeoutsArgsDict']]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RouteAggregationArgs.__new__(RouteAggregationArgs)

            __props__.__dict__["description"] = description
            __props__.__dict__["name"] = name
            if project is None and not opts.urn:
                raise TypeError("Missing required property 'project'")
            __props__.__dict__["project"] = project
            __props__.__dict__["timeouts"] = timeouts
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__.__dict__["type"] = type
            __props__.__dict__["change"] = None
            __props__.__dict__["change_log"] = None
            __props__.__dict__["connections_count"] = None
            __props__.__dict__["href"] = None
            __props__.__dict__["rules_count"] = None
            __props__.__dict__["state"] = None
            __props__.__dict__["uuid"] = None
        super(RouteAggregation, __self__).__init__(
            'equinix:fabric/routeAggregation:RouteAggregation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            change: Optional[pulumi.Input[Union['RouteAggregationChangeArgs', 'RouteAggregationChangeArgsDict']]] = None,
            change_log: Optional[pulumi.Input[Union['RouteAggregationChangeLogArgs', 'RouteAggregationChangeLogArgsDict']]] = None,
            connections_count: Optional[pulumi.Input[int]] = None,
            description: Optional[pulumi.Input[str]] = None,
            href: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            project: Optional[pulumi.Input[Union['RouteAggregationProjectArgs', 'RouteAggregationProjectArgsDict']]] = None,
            rules_count: Optional[pulumi.Input[int]] = None,
            state: Optional[pulumi.Input[str]] = None,
            timeouts: Optional[pulumi.Input[Union['RouteAggregationTimeoutsArgs', 'RouteAggregationTimeoutsArgsDict']]] = None,
            type: Optional[pulumi.Input[str]] = None,
            uuid: Optional[pulumi.Input[str]] = None) -> 'RouteAggregation':
        """
        Get an existing RouteAggregation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['RouteAggregationChangeArgs', 'RouteAggregationChangeArgsDict']] change: Current state of latest Route Aggregation change
        :param pulumi.Input[Union['RouteAggregationChangeLogArgs', 'RouteAggregationChangeLogArgsDict']] change_log: Details of the last change on the route aggregation resource
        :param pulumi.Input[int] connections_count: Number of Connections attached to route aggregation
        :param pulumi.Input[str] description: Customer-provided route aggregation description
        :param pulumi.Input[str] href: Equinix auto generated URI to the route aggregation resource
        :param pulumi.Input[str] name: Customer provided name of the route aggregation
        :param pulumi.Input[Union['RouteAggregationProjectArgs', 'RouteAggregationProjectArgsDict']] project: Equinix Project attribute object
        :param pulumi.Input[int] rules_count: Number of Rules attached to route aggregation
        :param pulumi.Input[str] state: Value representing provisioning status for the route aggregation resource
        :param pulumi.Input[str] type: Equinix defined Route Aggregation Type; BGP*IPv4*PREFIX*AGGREGATION, BGP*IPv6*PREFIX*AGGREGATION
        :param pulumi.Input[str] uuid: Equinix-assigned unique id for the route aggregation resource
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RouteAggregationState.__new__(_RouteAggregationState)

        __props__.__dict__["change"] = change
        __props__.__dict__["change_log"] = change_log
        __props__.__dict__["connections_count"] = connections_count
        __props__.__dict__["description"] = description
        __props__.__dict__["href"] = href
        __props__.__dict__["name"] = name
        __props__.__dict__["project"] = project
        __props__.__dict__["rules_count"] = rules_count
        __props__.__dict__["state"] = state
        __props__.__dict__["timeouts"] = timeouts
        __props__.__dict__["type"] = type
        __props__.__dict__["uuid"] = uuid
        return RouteAggregation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def change(self) -> pulumi.Output['outputs.RouteAggregationChange']:
        """
        Current state of latest Route Aggregation change
        """
        return pulumi.get(self, "change")

    @property
    @pulumi.getter(name="changeLog")
    def change_log(self) -> pulumi.Output['outputs.RouteAggregationChangeLog']:
        """
        Details of the last change on the route aggregation resource
        """
        return pulumi.get(self, "change_log")

    @property
    @pulumi.getter(name="connectionsCount")
    def connections_count(self) -> pulumi.Output[int]:
        """
        Number of Connections attached to route aggregation
        """
        return pulumi.get(self, "connections_count")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        Customer-provided route aggregation description
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def href(self) -> pulumi.Output[str]:
        """
        Equinix auto generated URI to the route aggregation resource
        """
        return pulumi.get(self, "href")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Customer provided name of the route aggregation
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def project(self) -> pulumi.Output['outputs.RouteAggregationProject']:
        """
        Equinix Project attribute object
        """
        return pulumi.get(self, "project")

    @property
    @pulumi.getter(name="rulesCount")
    def rules_count(self) -> pulumi.Output[int]:
        """
        Number of Rules attached to route aggregation
        """
        return pulumi.get(self, "rules_count")

    @property
    @pulumi.getter
    def state(self) -> pulumi.Output[str]:
        """
        Value representing provisioning status for the route aggregation resource
        """
        return pulumi.get(self, "state")

    @property
    @pulumi.getter
    def timeouts(self) -> pulumi.Output[Optional['outputs.RouteAggregationTimeouts']]:
        return pulumi.get(self, "timeouts")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        Equinix defined Route Aggregation Type; BGP*IPv4*PREFIX*AGGREGATION, BGP*IPv6*PREFIX*AGGREGATION
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def uuid(self) -> pulumi.Output[str]:
        """
        Equinix-assigned unique id for the route aggregation resource
        """
        return pulumi.get(self, "uuid")

